#include <afxwin.h>
#include <afxres.h>
#include <afxdlgs.h>
#include "resource.h"
#include "Wizard.h"

CSamplePropSheet *PropSheetPtr;

// Message map for the first page dialog box.
BEGIN_MESSAGE_MAP(CPropDialog1, CPropertyPage)
  ON_WM_PAINT()
  ON_COMMAND(IDD_ONE, OnOne)
  ON_COMMAND(IDD_TWO, OnTwo)
  ON_COMMAND(IDD_THREE, OnThree)
  ON_LBN_DBLCLK(IDD_LB1, OnListBox)
END_MESSAGE_MAP()

CPropDialog1::CPropDialog1():CPropertyPage()
{
};

BOOL CPropDialog1::OnInitDialog()
{
    int i;

	CPropertyPage::OnInitDialog(); // Call base class version

	CListBox *lbptr = (CListBox *) GetDlgItem(IDD_LB1);
	for(i=0; i<5; i++)
		lbptr->AddString(list[i]);
	lbptr->SetCurSel(0);

	m_bmp.LoadBitmap(IDB_BITMAP1);
		
	return TRUE;
}

BOOL CPropDialog1::OnApply()
{	  
  MessageBox("Selection Applied", "First Page");
  return TRUE;
}

BOOL CPropDialog1::OnSetActive()
{
  PropSheetPtr->SetWizardButtons(PSWIZB_NEXT);
  return TRUE;
}

void CPropDialog1::OnOne()
{
  CListBox *lbptr = (CListBox *) GetDlgItem(IDD_LB1);
  lbptr->SetCurSel(0);
}

void CPropDialog1::OnTwo()
{
  CListBox *lbptr = (CListBox *) GetDlgItem(IDD_LB1);
  lbptr->SetCurSel(1);
}

void CPropDialog1::OnThree()
{
  CListBox *lbptr = (CListBox *) GetDlgItem(IDD_LB1);
  lbptr->SetCurSel(2);
}

void CPropDialog1::OnListBox()
{
    int i;
	char str[255];
		
	CListBox *lbptr = (CListBox *) GetDlgItem(IDD_LB1);

	i = lbptr->GetCurSel();
	lbptr->GetText(i, str);

	MessageBox(str, "Selection is");
	SetModified(1);
}

void CPropDialog1::OnPaint()
{
	CPaintDC	DC(this);
	CDC			memDC;

	//create a compatible DC
	memDC.CreateCompatibleDC(&DC);

	//Select bitmap into memoryDC
	memDC.SelectObject(m_bmp);

	//copy the bitmap to windowDC
	DC.BitBlt(0,0,129,230,&memDC,0,0,SRCCOPY);
}


// Message map for the second page dialog box.
BEGIN_MESSAGE_MAP(CPropDialog2, CPropertyPage)
  ON_WM_PAINT()
  ON_COMMAND(IDD_INVERT, OnInvert)
  ON_COMMAND(IDD_CB1, OnCB1)
  ON_COMMAND(IDD_CB2, OnCB2)
  ON_COMMAND(IDD_CB3, OnCB3)
END_MESSAGE_MAP()

CPropDialog2::CPropDialog2() : CPropertyPage()
{
};

BOOL CPropDialog2::OnInitDialog()
{
    CPropertyPage::OnInitDialog(); // Call base class version

	CButton *cbptr = (CButton *) GetDlgItem(IDD_CB1);
	cbptr->SetCheck(1);
	m_bmp.LoadBitmap(IDB_BITMAP1);
	return TRUE;
}

BOOL CPropDialog2::OnApply()
{
  MessageBox("Selection Applied", "Second Page");
  return TRUE;
}

BOOL CPropDialog2::OnSetActive()
{
  PropSheetPtr->SetWizardButtons(PSWIZB_BACK|PSWIZB_NEXT);
  return TRUE;
}

void CPropDialog2::OnInvert()
{
	  // invert the check box selections
	  CButton *lbptr1 = (CButton *) GetDlgItem(IDD_CB1);
	  CButton *lbptr2 = (CButton *) GetDlgItem(IDD_CB2);
	  CButton *lbptr3 = (CButton *) GetDlgItem(IDD_CB3);
	  CButton *lbptr4 = (CButton *) GetDlgItem(IDD_CB4);

	  // invert the state of the check boxes
	  if(lbptr1->GetCheck())
		  lbptr1->SetCheck(0);
	  else
		  lbptr1->SetCheck(1);

	  if(lbptr2->GetCheck())
		  lbptr2->SetCheck(0);
	  else
		  lbptr2->SetCheck(1);

	  if(lbptr3->GetCheck())
		  lbptr3->SetCheck(0);
	  else 
		  lbptr3->SetCheck(1);

  	  if(lbptr4->GetCheck())
		  lbptr4->SetCheck(0);
	  else 
		  lbptr4->SetCheck(1);

	  SetModified(1);
}

void CPropDialog2::OnCB1()
{
	SetModified(1);
}

void CPropDialog2::OnCB2()
{
	SetModified(1);
}

void CPropDialog2::OnCB3()
{
	SetModified(1);
}

void CPropDialog2::OnPaint()
{
	CPaintDC	DC(this);
	CDC			memDC;

	//create a compatible DC
	memDC.CreateCompatibleDC(&DC);

	//Select bitmap into memoryDC
	memDC.SelectObject(m_bmp);

	//copy the bitmap to windowDC
	DC.BitBlt(0,0,129,230,&memDC,0,0,SRCCOPY);
}

// Message map for the third page dialog box.
BEGIN_MESSAGE_MAP(CPropDialog3, CPropertyPage)
  ON_COMMAND(IDD_TOP, OnTop)
  ON_COMMAND(IDD_BOTTOM, OnBottom)
  ON_COMMAND(IDD_RB1, OnRB1)
  ON_COMMAND(IDD_RB2, OnRB2)
  ON_COMMAND(IDD_RB3, OnRB3)
END_MESSAGE_MAP()

CPropDialog3::CPropDialog3() : CPropertyPage()
{
};

BOOL CPropDialog3::OnInitDialog()
{
    CPropertyPage::OnInitDialog(); // Call base class version
		
	CButton *cbptr = (CButton *) GetDlgItem(IDD_RB1);
	cbptr->SetCheck(1);
	return TRUE;
}

BOOL CPropDialog3::OnApply()
{
  MessageBox("Selection Applied", "Third Page");  
  return TRUE;
}

BOOL CPropDialog3::OnSetActive()
{
	PropSheetPtr->SetWizardButtons(PSWIZB_BACK|PSWIZB_FINISH);
	return TRUE;
}


void CPropDialog3::OnTop()
{
    CButton *lbptr1 = (CButton *) GetDlgItem(IDD_RB1);
	CButton *lbptr2 = (CButton *) GetDlgItem(IDD_RB2);
	CButton *lbptr3 = (CButton *) GetDlgItem(IDD_RB3);

	// turn off lower buttons
	lbptr2->SetCheck(0);
	lbptr3->SetCheck(0);
	lbptr1->SetCheck(1); // set top button
		
	SetModified(1);
}

void CPropDialog3::OnBottom()
{
    CButton *lbptr1 = (CButton *) GetDlgItem(IDD_RB1);
	CButton *lbptr2 = (CButton *) GetDlgItem(IDD_RB2);
	CButton *lbptr3 = (CButton *) GetDlgItem(IDD_RB3);

	// turn off lower buttons
	lbptr1->SetCheck(0); 
	lbptr2->SetCheck(0);
	lbptr3->SetCheck(1); // set bottomtop button
		
	SetModified(1);
}

void CPropDialog3::OnRB1()
{
  SetModified(1);
}

void CPropDialog3::OnRB2()
{
  SetModified(1);
}

void CPropDialog3::OnRB3()
{
	  SetModified(1);
}


CSamplePropSheet::CSamplePropSheet() : CPropertySheet()
{
    Construct("Sample Property Sheet", this);

    page1.Construct(IDD_PAGE1,0);
    page2.Construct(IDD_PAGE2,0);
    page3.Construct(IDD_PAGE3,0);
    AddPage(&page1);
    AddPage(&page2);
    AddPage(&page3);
  }

// This is the Main Window's message map.
BEGIN_MESSAGE_MAP(CMainWin, CFrameWnd)
  ON_COMMAND(ID_PROPERTYPAGE, OnPropertyPage)
  ON_COMMAND(ID_QUIT, OnQuit)
  ON_COMMAND(ID_HELP_ABOUT, OnHelp)
END_MESSAGE_MAP()

CMainWin::CMainWin()
{
    Create(NULL, "Using A Property Sheet",WS_OVERLAPPEDWINDOW, rectDefault,NULL,MAKEINTRESOURCE(IDR_MENU1));
	
	// Load accelerator table.
	if(!LoadAccelTable(MAKEINTRESOURCE(IDR_ACCELERATOR1)))
		MessageBox("Cannot Load Accelerators", "Error");

	PropSheetPtr=&m_PropSheet;
}

void CMainWin::OnPropertyPage()
{
	m_PropSheet.SetWizardMode();
	m_PropSheet.DoModal();
}

void CMainWin::OnQuit()
{
    int response;

	response = MessageBox("Quit the Program?","Exit", MB_YESNO);
	if(response == IDYES)
		SendMessage(WM_CLOSE); // terminate app
}

void CMainWin::OnHelp()
{
	MessageBox("Property Sheet", "Help");
}

BOOL CApp::InitInstance()
{
    m_pMainWnd = new CMainWin;
	m_pMainWnd->ShowWindow(m_nCmdShow);
	m_pMainWnd->UpdateWindow();

	return TRUE;

}

CApp TheApp;
